import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.awt.event.MouseMotionAdapter;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.Point;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
/**
 * Titre :        Logo
 * Description :  Interprteur Logo en java
 * Copyright :    Copyright (c) 2002
 * Socit :
 * @author Loc
 * @version 1.0
 */

public class Ardoise extends JPanel{
	private int bouton_souris=0;  	// Numro du bouton de souris appuy sur la zone de dessin
	String possouris="[ 0 0 ] ";	// Coordonnes du point du dernier vnement souris
  BufferedImage dessin;
  JScrollPane scroll;
	private	Click_Souris cs=new Click_Souris();
	private Bouge_Souris bs=new Bouge_Souris();
	private boolean lissouris=false; //Indique si un vnement souris est intervenu depuis le debut du programme
  public Ardoise() {
  }
  public Ardoise(JScrollPane scroll){
    this.scroll=scroll;
    try {
     jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
 
  public void paint(Graphics g){
    super.paint(g);
    try{
      g.setClip(scroll.getViewport().getViewRect());
      g.drawImage(dessin,0,0,this);
   }
   catch(java.lang.NullPointerException e){}
  }
  private void jbInit() throws Exception {
    this.setPreferredSize(new Dimension(Logo.largeur_dessin, Logo.hauteur_dessin));
   }
	 public void active_souris(){
		 lissouris=false;
		 addMouseListener(cs);
		 addMouseMotionListener(bs);
	 }
	 public void stop_souris(){
		 removeMouseListener(cs);
		 removeMouseMotionListener(bs);
	 }
	 public boolean get_lissouris(){
		 return lissouris;
	 }
	 public int get_bouton_souris(){
		 lissouris=false;
		 return bouton_souris;
	 }
	 public String get_possouris(){
		 lissouris=false;
		 return possouris;
	 }
	 class Click_Souris extends MouseAdapter{
		 public void mouseClicked(MouseEvent ev){
			 lissouris=true;
			 bouton_souris=ev.getButton();
			 Point point=ev.getPoint();
			 possouris="[ "+(point.x-Logo.largeur_dessin/2)+" "+(Logo.hauteur_dessin/2-point.y)+" ] ";
		 }
   }
   class Bouge_Souris extends MouseMotionAdapter{
		 public void mouseMoved(MouseEvent ev){
			 lissouris=true;
			 bouton_souris=0;
			 Point point=ev.getPoint();
			 possouris="[ "+(point.x-Logo.largeur_dessin/2)+" "+(Logo.hauteur_dessin/2-point.y)+" ] ";
		 }
	 }
}